import { ElementRef, EventEmitter, OnDestroy, OnInit, Renderer2, TemplateRef, ViewContainerRef } from '@angular/core';
import { CdkOverlayOrigin, Overlay, OverlayConfig, OverlayRef } from '@angular/cdk/overlay';
import { TemplatePortal } from '@angular/cdk/portal';
import { NzScrollStrategyOptions } from '../core/overlay/scroll/nz-scroll-strategy-options';
export declare type NzDrawerPlacement = 'top' | 'right' | 'bottom' | 'left';
export declare class NzDrawerComponent implements OnInit, OnDestroy {
    private renderer;
    private overlay;
    private elementRef;
    private nzScrollStrategyOptions;
    private viewContainerRef;
    origin: CdkOverlayOrigin;
    overlayRef: OverlayRef;
    portal: TemplatePortal;
    isOpen: boolean;
    readonly transform: string;
    readonly width: string;
    readonly height: string;
    readonly isLeftOrRight: boolean;
    drawerTemplate: TemplateRef<{}>;
    nzClosable: boolean;
    nzMaskClosable: boolean;
    nzMask: boolean;
    nzTitle: string | TemplateRef<{}>;
    nzMaskStyle: object;
    nzBodyStyle: object;
    nzWrapClassName: string;
    nzWidth: number | string;
    nzHeight: number | string;
    nzPlacement: NzDrawerPlacement;
    nzZIndex: number;
    nzOffsetX: number;
    nzOffsetY: number;
    nzOnClose: EventEmitter<MouseEvent>;
    nzVisible: boolean;
    isNonEmptyString(value: {}): boolean;
    isTemplateRef(value: {}): boolean;
    constructor(renderer: Renderer2, overlay: Overlay, elementRef: ElementRef, nzScrollStrategyOptions: NzScrollStrategyOptions, viewContainerRef: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    attachOverlay(): void;
    disposeOverlay(): void;
    getOverlayConfig(): OverlayConfig;
    updateOverlayStyle(): void;
    close(e?: MouseEvent): void;
    maskClick(e: MouseEvent): void;
}
